using System;
using RomeScriptInterfaces;
using Scripts;

namespace Scripts
{
    [Serializable]
    public class TwistedNicopolisNovice : ScriptServer.IScript
    {
        
        // for our messaging
        private String msgTitle, msgText;
        private String msgSound = "message1.mp3";
        private String msgApplause = "/../../sounds/events/event_circus_01.wav";
        private String msgRiot = "/../../sounds/events/event_coliseum_05.wav";
        private String msgMummy = "/../../sounds/buildings/obelisk_04.wav";
        private String msgBaa = "/../../sounds/actions/sheep_05.wav";
        private String msgNoSound = "";
        private String invasion;
        
        // variables for current ratings
        private Int32 nPopulation, nCityFunds, nSavings, eWC3;
        private uint nFavor, nSecurity, nCulture, nProsperity, nBeauty, uBeauty, nInsanity, uInsanity, eWC1, eWC2;
        private uint uDes, uUndes, uGovBR, uRelBR, uPatBR, uEntBR, uOtherBR, uSmallST, uMediumST, uLargeST, uTree1, uTree2, uBush, uGarden, uDeco, uTHB;
        private uint uISecurity, uIProsperity, uICulture, uIFunds, uIResource, uIWorkers;
        private uint uFinalInsanity, uMaxInsanity = 0;
        private uint uApr39Insanity, uAug39Insanity, uApr40Insanity, uAug40Insanity, uAug42Beauty, uFinalBeauty;
        private uint numEmployed = 0;
        // version specific targets
        private Int32 tPopulation = 6000;
        private Int32 tDefeat = -5000;

        // flags to tell us whether specific events have happened
        private bool bInit = false;
        private bool bScored = false;
        private bool bSwitchWarn = false;
        private bool bAssassinated = false;
        private bool bFinalInsanity = false;
        private bool bFireRisk = true;
        private bool bReviewed = false;
        private bool bBeauty = false;
        private bool bInsanityDay = false;
        private bool bInsaneWage = false;
        private bool bIAplague = false;
        private bool bIAfire = false;
        private bool bIAcollapse = false;
        private bool bIAkilts = false;
        private bool bDaggyBarber = false;
        private bool bDaggyWhips = false;
        private bool bDaggyStatue = false;
        private bool bDaggyFarm = false;
        private bool bDaggySysbe = false;
        private bool bDaggyLibrary = false;
        private bool bOdeum = false;
        private bool bJupiter = false;
        private bool bSchool = false;
        private bool bClinic = false;
        private bool bBarber = false;
        private bool bTheater = false;
        private bool bArena = false;
        private bool bColiseum = false;
        private bool bCircus = false;
        private bool bWageDown = false;
        private bool[] bEmptyVenue = { false, false, false, false };

        // variables for different checks
        private uint nTime = 0;                    // derived from game.GameTime
        private uint nTicks = 0;                   
        private uint[] nTimerCheck = { 340, 660, 980, 1300, 1620, 1940, 2260, 2580, 2900, 3220, 3540, 3860, 4180, 4500, 4820, 5140, 5460, 5780, 6100, 6420, 6660, 6740, 6820, 6900, 6980, 7075, 999999 };
        private String[] sTimeLeft = { "84", "80", "76", "72", "68", "64", "60", "56", "52", "48", "44", "40", "36", "32", "28", "24", "20", "16", "12", "8", "6", "4", "3", "2", "1", "0", "X" };
        private uint iMessage = 0;
        private uint tWageCheck = 2000;            // check after two years
        private uint tPayCheck = 3620;             // salary fixed at 2dn until the assassination
        private uint tClaudius = 3380;             // time of Caligula's assassination (3 months warning of)
        private uint iAdvisor = 0;                 // no Insanity Advisor appointed
        private uint iMaxVilla = 0;                // maximum level allowed by the Insanity Advisor
        private uint tInsanityCheck = 117;         // every 2 weeks, just before its end
        private uint tInsanityTip = 999999;
        private uint tAprInsanity = 1922;          // Insanity Day April 39AD
        private uint tAugInsanity = 2277;          // Insanity Day August 39AD
        private uint tBeautyCheck = 3877;          // every week, just before its end
        private uint tBeautyTip = 392;             // first tip at start of August 1st year
        private uint tEntCheck = 999999;
        private uint tBarberCheck = 999999;
        private uint tCBC = 1850;                  // Caligula's Beauty Contest, every February from 39AD
        private uint tAra = 2;
        private uint iLopok = 1;
        private uint iWarnIA = 0;                  // Insanity Advisor housing warning
        private uint iWarnCA = 0;                  // circus charioteer warning
        private uint tPerfectBeauty = 0;
        private uint tRazeLimit = 1;               // number of sheep farms to satisfy the Greeks
        private uint nInvasion = 1;                // sheep liberation front
        private uint rWool = 64;                   // resource trigger for SLF invasion
        private uint rDenarii = 25000;             // money trigger for SLF invasion
        private uint tSLF = 1200;                  // first raid by Sheep Liberation Front
        private uint kLopokium = 6;
        private uint kDefeat = 10;                 // Defeat city

        // variables for wage and population checks
        private Int32 nWageTrigger = 10000;        // first raise when city funds reach this level
        private int nPlebWages = 15;               // starting wages for plebs
        private int nEquiteWages = 20;             // ...and equites

        // resource IDs
        private Int32 mIDSand = IDMaker.FromString("C4cr Sand");
        private Int32 mIDArmor = IDMaker.FromString("C4cr Armor");
        private Int32 mIDWool = IDMaker.FromString("C4cr Wool");
        private Int32 mIDClay = IDMaker.FromString("C4cr Clay");
        private Int32 mIDMarble = IDMaker.FromString("C4cr Marble");
        private Int32 mIDGold = IDMaker.FromString("C4cr Gold");
        private Int32 mIDIron = IDMaker.FromString("C4cr Iron");
        private Int32 mIDTimber = IDMaker.FromString("C4cr Timber");
        private Int32 mIDCosmetics = IDMaker.FromString("C4cr Cosmetics");

        // building IDs
        private Int32 mIDPalace1 = IDMaker.FromString("C4b Governor's Palace Small");
        private Int32 mIDPalace2 = IDMaker.FromString("C4b Governor's Palace Medium");
        private Int32 mIDPalace3 = IDMaker.FromString("C4b Governor's Palace Large");
        private Int32 mIDTaxOffice = IDMaker.FromString("C4b Office Tax Collector");
        private Int32 mIDPrefect = IDMaker.FromString("C4b Office Praefect");
        
        private Int32 mIDDomus1 = IDMaker.FromString("C4b Equites Housing 01");
        private Int32 mIDDomus2 = IDMaker.FromString("C4b Equites Housing 02");
        private Int32 mIDDomus3 = IDMaker.FromString("C4b Equites Housing 03");
        private Int32 mIDInsula1 = IDMaker.FromString("C4b Plebian home 01");
        private Int32 mIDInsula2 = IDMaker.FromString("C4b Plebian home 02");
        private Int32 mIDInsula3 = IDMaker.FromString("C4b Plebian home 03");
        private Int32 mIDVilla1 = IDMaker.FromString("C4b Patrician home 01");
        private Int32 mIDVilla3 = IDMaker.FromString("C4b Patrician home 03");
        private Int32 mIDEstate1 = IDMaker.FromString("C4b Patrician home 04");
        private Int32 mIDEstate2 = IDMaker.FromString("C4b Patrician home 05");
        private Int32 mIDEstate3 = IDMaker.FromString("C4b Patrician home 06");
        private Int32 mIDMansion1 = IDMaker.FromString("C4b Patrician home 07");
        private Int32 mIDMansion2 = IDMaker.FromString("C4b Patrician home 08");
        private Int32 mIDMansion3 = IDMaker.FromString("C4b Patrician home 09");
        private Int32 mIDForum = IDMaker.FromString("C4b service Forum");
        private Int32 mIDBasilica = IDMaker.FromString("C4b service Basilica");
        private string[] sPatricians = {"C4b Patrician home 01","C4b Patrician home 02","C4b Patrician home 03",
             "C4b Patrician home 04","C4b Patrician home 05","C4b Patrician home 06","C4b Patrician home 07",
             "C4b Patrician home 08","C4b Patrician home 09"};

        private Int32 mIDFountain = IDMaker.FromString("C4b infra Fountain");
        private Int32 mIDPumphouse = IDMaker.FromString("C4b Infra Pumphouse");
        private Int32 mIDReservoir = IDMaker.FromString("C4b service Reservoir");
        private Int32 mIDBarber = IDMaker.FromString("C4b service Barber shop");
        private Int32 mIDBathhouse = IDMaker.FromString("C4b service Bathhouse");
        private Int32 mIDClinic = IDMaker.FromString("C4b service Clinic");
        private Int32 mIDHospital = IDMaker.FromString("C4b service Hospital");
        private Int32 mIDLibrary = IDMaker.FromString("C4b service Library");
        private Int32 mIDSchool = IDMaker.FromString("C4b service School");
        //
        private Int32 mIDJupiterTemple = IDMaker.FromString("C4b Service Temple Jupiter");
        private Int32 mIDCeresTemple = IDMaker.FromString("C4b Service Temple Ceres");
        private Int32 mIDMarsTemple = IDMaker.FromString("C4b Service Temple Mars");
        private Int32 mIDBacchusTemple = IDMaker.FromString("C4b Service Temple Bacchus");
        private Int32 mIDMercuryTemple = IDMaker.FromString("C4b Service Temple Mercury");
        private Int32 mIDJupiterShrine = IDMaker.FromString("C4b Service Shrine Jupiter");
        private Int32 mIDCeresShrine = IDMaker.FromString("C4b Service Shrine Ceres");
        private Int32 mIDMarsShrine = IDMaker.FromString("C4b Service Shrine Mars");
        private Int32 mIDBacchusShrine = IDMaker.FromString("C4b Service Shrine Bacchus");
        private Int32 mIDMercuryShrine = IDMaker.FromString("C4b Service Shrine Mercury");
        //
        private Int32 mIDOdeum = IDMaker.FromString("C4b service Odeum");
        private Int32 mIDTheater = IDMaker.FromString("C4b service Theater");
        private Int32 mIDArena = IDMaker.FromString("C4b service Arena");
        private Int32 mIDColiseum = IDMaker.FromString("C4b service Coliseum");
        private Int32 mIDCircus = IDMaker.FromString("C4b service Circus");
        private Int32 mIDActor = IDMaker.FromString("C4b Training Actor");
        private Int32 mIDAnimalTrainer = IDMaker.FromString("C4b Training Animal");
        private Int32 mIDGladiator = IDMaker.FromString("C4b Training Gladiator");
        private Int32 mIDCharioteer = IDMaker.FromString("C4b Training Charioteer");
        //
        private Int32 mIDCattleFarm = IDMaker.FromString("C4b harvester Livestock farmer's house");
        private Int32 mIDSheepFarm = IDMaker.FromString("C4b harvester Wool farmer's house");
        private Int32 mIDSheepPasture = IDMaker.FromString("c4r Sheep Pasture");
        private Int32 mIDSandCamp = IDMaker.FromString("C4b harvester Sand collector's house");
        private Int32 mIDClayCamp = IDMaker.FromString("C4b harvester Clay collector's house");
        private Int32 mIDLumberjack = IDMaker.FromString("C4b harvester Timber miller's house");
        private Int32 mIDIronMine = IDMaker.FromString("C4b harvester Iron miner's house");
        private Int32 mIDGoldMine = IDMaker.FromString("C4b harvester Gold miner's house");
        private Int32 mIDMarbleCamp = IDMaker.FromString("C4b harvester Marble collector's camp");
        private Int32 mIDGlassFactory = IDMaker.FromString("C4b factory Glass");
        private Int32 mIDJewelryFactory = IDMaker.FromString("C4b factory Jewelry");
        private Int32 mIDOliveOilFactory = IDMaker.FromString("C4b factory Olive Oil");
        private Int32 mIDWineFactory = IDMaker.FromString("C4b factory Wine");
        private Int32 mIDPotteryFactory = IDMaker.FromString("C4b factory Pottery");
        private Int32 mIDUtensilsFactory = IDMaker.FromString("C4b factory Utensils");
        private Int32 mIDWeaponsFactory = IDMaker.FromString("C4b factory Weapons");
        //
        private Int32 mIDFoodMarket = IDMaker.FromString("C4b Market Food");
        private Int32 mIDBasicMarket = IDMaker.FromString("C4b market Common");
        private Int32 mIDLuxuryMarket = IDMaker.FromString("C4b Market Luxury");
        private Int32 mIDExoticMarket = IDMaker.FromString("C4b Market Exotic");
        private Int32 mIDGranary = IDMaker.FromString("C4b infra Granary");
        private Int32 mIDWarehouse = IDMaker.FromString("C4b infra Warehouse");
        private Int32 mIDDepot = IDMaker.FromString("C4b Depot");
        private Int32 mIDPort = IDMaker.FromString("C4b Depot with Dock");
        //
        private Int32 mIDArmory = IDMaker.FromString("C4b Mil Armory");
        private Int32 mIDMessHall = IDMaker.FromString("C4b Mil Mess Hall");
        private Int32 mIDTower = IDMaker.FromString("C4b infra Tower");
        private Int32 mIDGatehouse = IDMaker.FromString("C4b infra Gate");
        private Int32 mIDDrillYard = IDMaker.FromString("C4b Mil Drill Yard");
        private Int32 mIDArchers = IDMaker.FromString("C4b Mil Fort Auxilia");
        private Int32 mIDLightInfantry = IDMaker.FromString("C4b Mil Fort Infantry Lt");    
        // 
        private Int32 mIDGarden = IDMaker.FromString("C4 Deco Garden");
        private Int32 mIDHedgeSmall = IDMaker.FromString("C4 Deco Hedge Small");
        private Int32 mIDHedgeLarge = IDMaker.FromString("C4 Deco Hedge Large");
        private Int32 mIDBushSmall = IDMaker.FromString("C4 Deco Bush Small");
        private Int32 mIDBushLarge = IDMaker.FromString("C4 Deco Bush Large");
        private Int32 mIDTreeSmall = IDMaker.FromString("C4 Deco Tree Small");
        private Int32 mIDTreeMedium = IDMaker.FromString("C4 Deco Tree Medium");
        private Int32 mIDTreeLarge = IDMaker.FromString("C4 Deco Tree Large");
        private Int32 mIDHedgeRowSmall = IDMaker.FromString("C4 Deco HedgeRow Small");
        private Int32 mIDHedgeRowLarge = IDMaker.FromString("C4 Deco HedgeRow Large");
        private Int32 mIDStatue1 = IDMaker.FromString("C4 Deco Statue 1");
        private Int32 mIDStatue2 = IDMaker.FromString("C4 Deco Statue 2");
        private Int32 mIDStatue3 = IDMaker.FromString("C4 Deco Statue 3");
        private Int32 mIDStatue4 = IDMaker.FromString("C4 Deco Statue 4");
        private Int32 mIDStatue5 = IDMaker.FromString("C4 Deco Statue 5");
        private Int32 mIDStatue6 = IDMaker.FromString("C4 Deco Statue 6");
        private Int32 mIDObelisk = IDMaker.FromString("C4b Statue Obelisk");

        // build button IDs
        private Int32 mUIIDStorage = IDMaker.FromString("STORAGE");
        private Int32 mUIIDPatHome = IDMaker.FromString("PAT_HOME");
        private Int32 mUIIDExoticMarket = IDMaker.FromString("MARKET_EXOTIC");
        
        private Int32 mUIIDSafety = IDMaker.FromString("SAFETY");
        private Int32 mUIIDPrefect = 276325365;
        private Int32 mUIIDGrainFarm = 939069272;
        private Int32 mUIIDVegFarm = 899170814;
        private Int32 mUIIDCattleFarm = -456233970;
        private Int32 mUIIDOliveFarm = 697536400;
        private Int32 mUIIDGrapeFarm = -187939099;
        private Int32 mUIIDGrainField = 1892088299;
        private Int32 mUIIDVegField = 1892088301;
        private Int32 mUIIDCattlePasture = 1853760927;
        private Int32 mUIIDOliveGrove = 1892088303;        
        private Int32 mUIIDJupiterShrine = -1298997106;
        private Int32 mUIIDJupiterTemple = 1121480186;
        private Int32 mUIIDClinic = IDMaker.FromString("CLINIC");
        private Int32 mUIIDBarber = -1282219398;
        private Int32 mUIIDSchool = -1298997109;
        private Int32 mUIIDTax = 276325360;
        private Int32 mUIIDBust = IDMaker.FromString("STATUE1");
        private Int32 mUIIDStanding = IDMaker.FromString("STATUE2");
        private Int32 mUIIDHuntsman = IDMaker.FromString("STATUE3");
        private Int32 mUIIDHorseman = IDMaker.FromString("STATUE4");
        private Int32 mUIIDChariot = -1047491516;
        private Int32 mUIIDWingedChariot = -997158636;
        private Int32 mUIIDSmallHedgeRow = -1282219395;
        private Int32 mUIIDLargeHedgeRow = -1298997118;
        private Int32 mUIIDGarden = IDMaker.FromString("GARDEN1");
        private Int32 mUIIDSmallHedge = IDMaker.FromString("DECO1");
        private Int32 mUIIDLargeHedge = IDMaker.FromString("DECO7");
        private Int32 mUIIDSmallBush = IDMaker.FromString("DECO2");
        private Int32 mUIIDLargeBush = IDMaker.FromString("DECO4");
        private Int32 mUIIDSmallTree = IDMaker.FromString("DECO6");
        private Int32 mUIIDMediumTree = IDMaker.FromString("DECO3");
        private Int32 mUIIDLargeTree = IDMaker.FromString("DECO5");
        private Int32 mUIIDObelisk = IDMaker.FromString("PRESALE1");
        private Int32 mUIIDOdeum = 1740942627;
        private Int32 mUIIDTheater = -137606214;
        private Int32 mUIIDActor = 1806783073;
        private Int32 mUIIDArena = 1724165050;
        private Int32 mUIIDGladiator = 1806783075;
        private Int32 mUIIDColiseum = 1691448420;
        private Int32 mUIIDCircus = -2046596977;
        private Int32 mUIIDSalary = 989726645;
         
        // The following declarations are necessary as this scenario uses custom standward wage changes
        private StandardWageManager mWageManagerPlebe = null;
        private StandardWageManager mWageManagerEques = null;

        private TMilitaryAI mMilitaryAI = null;
        private InvasionSetup[] mInvasions;

        // This is the main script loop
        public void Run(object gameInterface)
        {
            IGameQueryInterface gameQueryInterface = (IGameQueryInterface)gameInterface;
            switch (gameQueryInterface.RunReason)
            {
                case RunReason.kTick:
                    OnTick(gameQueryInterface);
                    break;

                case RunReason.kOnBeginScenario:
                    OnBeginScenario(gameQueryInterface);
                    break;

                case RunReason.kOnInvasionArrival:
                    OnInvasionArrival(gameQueryInterface);
                    break;

                case RunReason.kOnCohortTargetDestroyed:
                    OnCohortTargetDestroyed(gameQueryInterface);
                    break;

                case RunReason.kOnLoadScenario:
                    OnScenarioLoad(gameQueryInterface);
                    break;
            }
        }

        void OnTick(IGameQueryInterface game)
        {
            if (bInit)
            {
                bInit = false;
                ResetBaseUI(game);
            }

            nTicks++;
            if (nTicks == 2)
            {
                InvasionSetup mInvasion;
                invasion = "Carts";
                mInvasion = new InvasionSetup(invasion, sInvasionFactions.kGaul,
                                     eInvasionType.kInvasion, 0, 4, 0);
                mInvasion.AddCohort("COHORT_COWHORT", 1, 9, 10);
                mInvasion.CreateInvasion(game, 0, 0);
                // this starts the invasion we have set up
                game.StartInvasion(ref invasion);
            }
            else if (nTicks == 4)
            {
                game.UnlockUIControl(mUIIDSafety, Toolset.MainGameFormID);
                game.UnlockUIControl(mUIIDPrefect, Toolset.MainGameFormID);
                StopCurrentInvasion(game);
            }
            
            // Set our city ratings
            GetCityRatings(game);

            SetFireRisk(game);

            if (nTime > nTimerCheck[iMessage]) TimerMessage(game);

            if (nTime > tAra)
                Dagginess(game);
            else if (!bInsanityDay && (nTime > 1640))
            {
                DisplayMessage(game, "Insanity_Day");
                bInsanityDay = true;
            }
            else if (nTime > tSLF)
                // check for invasion from the SLF
                SheepLiberationFront(game);
            else if (game.AnyActiveInvasions && (game.BuildingsRazed >= tRazeLimit))
                StopCurrentInvasion(game);
            else if (nTime > tEntCheck)
                // can we unlock anything based on population?
                CheckEntertainment(game);
            else if (nTime > tWageCheck)
                // are wage expectations raised (or lowered)?
                CheckWageExpectations(game);
            else if (nTime > tCBC)
                CBCAward(game);
            else if (nTime > tClaudius)
            {
                if (!bSwitchWarn)
                    SwitchWarning(game);
                else if (!bAssassinated)
                    AssassinateCaligula(game);
                else if (!bFinalInsanity)
                    FinalReckoning(game);
                else if (!bReviewed)
                    ReviewStatus(game);
                else if (!bBeauty)
                    AppointAdvisor(game);
            }
            
            // mMilitaryAI.Update(game, 0.1);
        }

        ////////////////////////////////////////////////
        // This is where we get the city ratings etc
        void GetCityRatings(IGameQueryInterface game)
        {
            nTime = game.GameTime / 1000;           // time measured in seconds
            if (nTime > 7080) game.ScriptDone = true;
            game.GetFavorRating(out nFavor);
            game.GetSecurityRating(out nSecurity);
            game.GetProsperityRating(out nProsperity);
            game.GetCultureRating(out nCulture);
            game.GetPopulation(out nPopulation);
            game.GetGovernorPersonalFunds(out nSavings);
            game.GetCityFunds(out nCityFunds);

            if (!bScored && (nTime > 7080)) SetPointsScore(game);

            // check for defeat triggers
            if ((nCityFunds <= tDefeat) || (nPopulation > tPopulation) || (nTime > 7090))
            {
                TriggerDefeat(game);
            }
            
            if (nTime > tInsanityCheck)
                ShowInsanityRating(game);
            else if (nTime > tBeautyCheck) 
                ShowBeautyRating(game);

        }

        /////////////////////////////////////////////
        // This is where we set the final points
        void SetPointsScore(IGameQueryInterface game)
        {
            uint minIR = 0;
            minIR = uApr39Insanity;
            if (uAug39Insanity < minIR) minIR = uAug39Insanity;
            if (uApr40Insanity < minIR) minIR = uApr40Insanity;
            if (uAug40Insanity < minIR) minIR = uAug40Insanity;
            if (uFinalInsanity < minIR) minIR = uFinalInsanity;
            eWC1 = uMaxInsanity + Math.Min(minIR, 100) + uAug42Beauty + 2 * uFinalBeauty;
            eWC2 = nFavor;
            eWC3 = nCityFunds;
            //game.SetRomeStandardRate(true, (int)eWC1);
            //game.SetRomeStandardRate(false, (int)eWC2);
            //game.SetRomeStandardRate(true, eWC3 / 100000);
            //game.SetRomeStandardRate(false, eWC3);
            bScored = true;
        }

        //////////////////////////////////////////
        // Controls fires (easy & novice)
        void SetFireRisk(IGameQueryInterface game)
        {
            uint nP;
            
            game.GetActiveBuildings(mIDPrefect, out nP);
            if (bFireRisk && (nP > 9))
            {
                bFireRisk = false;
                DisplayWarning(game, "Fire_Protect");
            }
            else if (!bFireRisk && (nP < 10))
            {
                bFireRisk = true;
                DisplayWarning(game, "Fire_Risk");
            }
            game.SetFireCollapse(bFireRisk);
        }

        //////////////////////////////////////////////////
        // Controls the raider invasions
        void SheepLiberationFront(IGameQueryInterface game)
        {
            InvasionSetup mInvasion;
            uint nWool = 0;

            game.GetResource(mIDWool, out nWool);
            if ((nWool >= rWool) || (nCityFunds > rDenarii))
            {
                if (nWool >= rWool)
                    rWool += 64;
                else
                    rDenarii += 25000;
            
                DisplayMessage(game, "SLF");
                invasion = "raid" + nInvasion.ToString(); ;
                mInvasion = new InvasionSetup(invasion, "Greek", eInvasionType.kInvasion, 0, 4, 0);
                mInvasion.AddCohort("ENEMY_GREEK_AUX", 1, 15, 15);
                mInvasion.CreateInvasion(game, nInvasion, 0);
                game.StartInvasion(ref invasion);
                nInvasion++;
                tSLF = nTime + 840;       // 42 weeks to next raid (at least)
                tRazeLimit++;             // next time they will want more...
            }
            else
                tSLF = nTime + 40;        // check every 2 weeks otherwise
        }

        ///////////////////////////////////////////
        // Check for an over/underpaid Governor
        void SalaryCheck(IGameQueryInterface game)
        {
            uint gRank, gSalary, n1, n2, n3;
            
            game.GetGovernorRank(out gRank);
            game.GetGovernorSalaryLevel(out gSalary);

            if (gSalary > gRank)
            {
                game.GetTotalBuildings(mIDTaxOffice, out n1);
                game.GetTotalBuildings(mIDForum, out n2);
                game.GetTotalBuildings(mIDBasilica, out n3);
                Int32 mID = mPalace(game);
                if (n1 > 0)
                {
                    DisplayRiot(game, "Tax_Riot_C");
                    game.TriggerFireDamage(mIDTaxOffice, (int)n1, 99);
                }
                else if (mID != 0)
                {
                    DisplayRiot(game, "Tax_Riot_P");
                    game.TriggerFireDamage(mID, 1, 99);
                }
                else if (n2 > 0)
                {
                    DisplayRiot(game, "Tax_Riot_F");
                    game.TriggerFireDamage(mIDForum, 1, 99);
                }
                else if (n3 > 0)
                {
                    DisplayRiot(game, "Tax_Riot_B");
                    game.TriggerFireDamage(mIDBasilica, 1, 99);
                }
            }
            tPayCheck += 20;
        }

        ////////////////////////////////////////////
        // Reminder of interim completion criteria
        void SwitchWarning(IGameQueryInterface game)
        {
            uint n1, n2, n3, n4, n5, n6, num;
            game.GetTotalBuildings(mIDEstate1, out n1);
            game.GetTotalBuildings(mIDEstate2, out n2);
            game.GetTotalBuildings(mIDEstate3, out n3);
            game.GetTotalBuildings(mIDMansion1, out n4);
            game.GetTotalBuildings(mIDMansion2, out n5);
            game.GetTotalBuildings(mIDMansion3, out n6);
            // this should be 4 Small Mansions (Insane), Large Estates (Hard)
            // Medium Estates (Easy) and Small Estates (Novice)
            num = n1 + n2 + n3 + n4 + n5 + n6;

            if ((num < 4) && (nPopulation < 4000))
                DisplayWarning(game, "Warn_PatPop");
            else if (nPopulation < 4000)
                DisplayWarning(game, "Warn_Pop");
            else if (num < 4)
                DisplayWarning(game, "Warn_Pat");

            bSwitchWarn = true;
            tClaudius = 3620;
        }

        ///////////////////////////////////////
        // In which Caligula gets assassinated
        void AssassinateCaligula(IGameQueryInterface game)
        {
            bAssassinated = true;
            msgTitle = "Assassinated_Title";
            msgText = "Assassinated_Message";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref msgApplause);
            tInsanityCheck = 999999;
            tClaudius = 3630;
            tPopulation = 9999999;
            nPlebWages = 15;
            nEquiteWages = 20;
            game.SetRomeStandardRate(true, nPlebWages);
            game.SetRomeStandardRate(false, nEquiteWages);
        }

        /////////////////////////////////////////////
        // Display Final Insanity Rating
        void FinalReckoning(IGameQueryInterface game)
        {
            DisplaySpecialInsanity(game, "Final");
            uFinalInsanity = nInsanity;
            tClaudius = 3640;
            bFinalInsanity = true;
        }

        ///////////////////////////////////////////
        // Claudius checks on city status
        void ReviewStatus(IGameQueryInterface game)
        {
            uint n1, n2, n3, n4, n5, n6, num;
            game.GetTotalBuildings(mIDEstate1, out n1);
            game.GetTotalBuildings(mIDEstate2, out n2);
            game.GetTotalBuildings(mIDEstate3, out n3);
            game.GetTotalBuildings(mIDMansion1, out n4);
            game.GetTotalBuildings(mIDMansion2, out n5);
            game.GetTotalBuildings(mIDMansion3, out n6);
            // this should be 4 Small Mansions (Insane), Large Estates (Hard)
            // Medium Estates (Easy) and Small Estates (Novice)
            num = n1 + n2 + n3 + n4 + n5 + n6;

            if ((num < 4) || (nPopulation < 4000))
                TriggerDefeat(game);
            else
            {
                nInsanity = uMaxInsanity;
                DisplaySpecialInsanity(game, "Maximum");    
            }
            // enable tax and pasture things
            game.UnlockUIControl(mUIIDTax, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDGrainFarm, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDVegFarm, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDCattleFarm, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDOliveFarm, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDGrapeFarm, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDGrainField, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDVegField, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDCattlePasture, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDOliveGrove, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDSalary, Toolset.AdvisorsFormID);
            game.UnlockUIControl(-732577675, Toolset.AdvisorsFormID);
 
            bReviewed = true;
            tClaudius = 3650;
        }

        /////////////////////////////////////////////
        // Claudius appoints a Beauty Advisor
        void AppointAdvisor(IGameQueryInterface game)
        {
            bBeauty = true;
            msgTitle = "Beauty_Advisor_Title";
            msgText = "Beauty_Advisor_Message";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref msgApplause);
            // enable decorative items
            game.UnlockUIControl(mUIIDBust, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDStanding, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDSmallHedgeRow, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDLargeHedgeRow, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDSmallHedge, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDLargeHedge, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDSmallBush, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDLargeBush, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDGarden, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDSmallTree, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDMediumTree, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDLargeTree, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDHuntsman, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDHorseman, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDChariot, Toolset.MainGameFormID);
            game.UnlockUIControl(mUIIDWingedChariot, Toolset.MainGameFormID);
            // initialise beauty rating, to a maximum of 36
            GetBeautyRating(game);
            nBeauty = Math.Min(uBeauty, 36);
        }

        /////////////////////////////////////////////////
        // Caligula's Beauty Contest Award, 39AD and 40AD
        void CBCAward(IGameQueryInterface game)
        {
            if (nTime < 2000)
                DisplayMessage(game, "CBC_39");
            else if (nTime < 3000)
                DisplayMessage(game, "CBC_40");
            tCBC += 960;
        }


        //////////////////////////////////////////
        // Story of the Lopok...
        void Dagginess(IGameQueryInterface game)
        {
            Int32 mID = mPalace(game);
            uint nBarber, nSheep, nWhips, nWool, nCosmetics, nLibrary, nStatues;
                
            switch (iLopok)
            {
                    
                case 1:
                    DisplayMessage(game, "Sun_Goddess");
                    tAra = 1105;
                    iLopok = 2;
                    break;

                case 2:
                    if (mID != 0)
                    {
                        DisplayRiot(game, "Lopok_Riot");
                        game.TriggerFireDamage(mID, 1, 100);
                        tAra = 1135;
                        iLopok = 3;
                    }
                    else if (tAra < 1130)
                        tAra += 5;
                    else
                    {
                        tAra = 1135;
                        iLopok = 3;
                    }
                    break;

                case 3:
                    if (mID != 0)
                    {
                        DisplayMessage(game, "Lopok_Hunt");
                        tAra += 40;
                        iLopok = 4;
                    }
                    else
                    {
                        DisplayMessage(game, "No_Lopok_Hunt");
                        tAra += 960;
                    }
                    break;

                case 4:
                    DisplayMessage(game, "Lopok_Trap");
                    game.OpenTradeRoute(kLopokium);
                    game.FlashUIControl(mUIIDStorage, Toolset.MainGameFormID, 1000);
                    tAra = 5000;
                    iLopok = 5;
                    break;

                case 5:
                    DisplayMessage(game, "OGH_Speaks");
                    tAra = 5200;
                    iLopok = 6;
                    break;

                case 6:
                    game.GetActiveBuildings(mIDBarber, out nBarber);
                    game.GetActiveBuildings(mIDLibrary, out nLibrary);
                    game.GetResource(mIDCosmetics, out nCosmetics);
                    game.GetTotalBuildings(mIDTreeLarge, out nWhips);
                    game.GetResource(mIDWool, out nWool);
                    game.GetTotalBuildings(mIDStatue2, out nStatues);
                    game.GetActiveBuildings(mIDSheepFarm, out nSheep);
                                            
                    if (!bDaggyLibrary && (nLibrary > 1))
                    {
                        game.TriggerFireDamage(mIDLibrary, 2, 99);
                        DisplayRiot(game, "Sysbe_Library");
                        bDaggyLibrary = true;
                    }
                    else if (!bDaggyBarber && ((nBarber > 0) && (nCosmetics == 3)))
                    {
                        game.TriggerFireDamage(mIDBarber, 1, 99);
                        DisplayRiot(game, "Daggy_Barber");
                        bDaggyBarber = true;
                    }
                    else if (!bDaggyWhips && (nWhips > 6) && (nWool > 30))
                    {
                        game.TriggerFireDamage(mIDBasicMarket, 1, 99);
                        DisplayRiot(game, "Daggy_Whips");
                        bDaggyWhips = true;
                    }
                    else if (!bDaggyStatue && (nStatues > 6))
                    {
                        game.TriggerFireDamage(mIDStatue2, 7, 99);
                        DisplayRiot(game, "Daggy_Statues");
                        bDaggyStatue = true;
                    }
                    else if (!bDaggyFarm && (nSheep == 17))
                    {
                        game.TriggerFireDamage(mIDSheepPasture, 1, 99);
                        DisplayRiot(game, "Is_That_WOOL");
                        bDaggyFarm = true;
                    }
                    else
                    {
                        uint nT, nTemples;
                        Int32 mIDTemple = mIDJupiterTemple;
                        game.GetActiveBuildings(mIDTemple, out nTemples);
                        game.GetActiveBuildings(mIDMercuryTemple, out nT);
                        if (nT > nTemples)
                        {
                            mIDTemple = mIDMercuryTemple;
                            nTemples = nT;
                        }
                        game.GetActiveBuildings(mIDCeresTemple, out nT);
                        if (nT > nTemples)
                        {
                            mIDTemple = mIDCeresTemple;
                            nTemples = nT;
                        }
                        game.GetActiveBuildings(mIDBacchusTemple, out nT);
                        if (nT > nTemples)
                        {
                            mIDTemple = mIDBacchusTemple;
                            nTemples = nT;
                        }
                        game.GetActiveBuildings(mIDMarsTemple, out nT);
                        if (nT > nTemples)
                        {
                            mIDTemple = mIDMarsTemple;
                            nTemples = nT;
                        }
                        if (nTemples > 2)
                        {
                            game.TriggerFireDamage(mIDTemple, (int)nTemples, 99);
                            DisplayRiot(game, "Ara_Insulted");
                        }
                    }
                    tAra = nTime + 79;
                    break;
            }
        }

        

        /////////////////////////////////////////////////////
        // Unlock entertainment venues based on trade opened 
        void CheckEntertainment(IGameQueryInterface game)
        {
            uint nR1, nB1, tInterval = 160;
            if (!bCircus)
            {
                game.GetActiveBuildings(mIDCharioteer, out nB1);
                game.GetResource(mIDArmor, out nR1);
                if (nB1 < 1)
                {
                    if (iWarnCA == 0) DisplayMessage(game, "Need_Charioteers");
                    iWarnCA = 12;
                }
                else if (nR1 > 3)
                {
                    bCircus = true;
                    game.UnlockUIControl(mUIIDCircus, Toolset.MainGameFormID);
                    DisplayWarning(game, "Circus_Open");
                }
                else if (iWarnCA == 12)
                {
                    DisplayMessage(game, "Arm_Charioteers");
                    tInterval = 20;
                    iWarnCA = 1;
                }
                else
                {
                    tInterval = 20;
                    iWarnCA++;
                }
            }
            else if (!bColiseum)
            {
                if (nPopulation >= 1000)
                {
                    game.UnlockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
                    DisplayWarning(game, "Coliseum_Open");
                    bColiseum = true;
                }
            }
            else if (!bJupiter)
            {
                if (nPopulation >= 1500)
                {
                    bJupiter = true;
                    game.UnlockUIControl(mUIIDJupiterShrine, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDJupiterTemple, Toolset.MainGameFormID);
                    DisplayWarning(game, "Jupiter_Open");
                }
            }
            else if (!bArena)
            {
                if (nPopulation >= 2000)
                {
                    bArena = true;
                    game.UnlockUIControl(mUIIDArena, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
                    DisplayWarning(game, "Arena_Open");
                }
            }
            else if (!bTheater)
            {
                if (nPopulation >= 2500)
                {
                    bTheater = true;
                    game.UnlockUIControl(mUIIDTheater, Toolset.MainGameFormID);
                    game.UnlockUIControl(mUIIDActor, Toolset.MainGameFormID);
                    DisplayWarning(game, "Theater_Open");
                }
            }
            else if (!bSchool)
            {
                if (nPopulation >= 2750)
                {
                    bSchool = true;
                    game.UnlockUIControl(mUIIDSchool, Toolset.MainGameFormID);
                    DisplayWarning(game, "School_Open");
                }
            }
            else if (!bOdeum)
            {
                if (nPopulation >= 3000)
                {
                    game.UnlockUIControl(mUIIDOdeum, Toolset.MainGameFormID);
                    DisplayWarning(game, "Odeum_Open");
                    bOdeum = true;
                }
            }
            else if (!bClinic)
            {
                if (nPopulation >= 3250)
                {
                    game.UnlockUIControl(mUIIDClinic, Toolset.MainGameFormID);
                    DisplayWarning(game, "Clinic_Open");
                    bClinic = true;
                }
            }
            else if (!bBarber)
            {
                if (nPopulation >= 3500)
                {
                    bBarber = true;
                    game.UnlockUIControl(mUIIDBarber, Toolset.MainGameFormID);
                    DisplayWarning(game, "Barber_Open");
                    tBarberCheck = nTime + 240;
                }
            }
            tEntCheck = nTime + tInterval;
        }

        ////////////////////////////////////////////////////////////////////////////
        // Insanity rating is calculated every 2 weeks
        // Current rating increases or decreases by 1 every week towards this value
        void ShowInsanityRating(IGameQueryInterface game)
        {
            uint uMaxVilla = MaxVilla(game);
            uint nPV, nI2, nI3, nD2, nD3;
            bool bEdomus = false;
            bool bEinsula = false;

            switch (iAdvisor)
            {
                case 0:
                    DisplayMessage(game, "Advisor_Guest");
                    iAdvisor = 1;
                    break;

                case 1:
                    if (nPalace(game) > 0)
                    {
                        DisplayMessage(game, "Advisor_Home");
                        game.UnlockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
                        iAdvisor = 2;
                        tEntCheck = nTime + 80;
                    }
                    break;

                case 2:
                    uint iVillaIA = 2;
                    
                    if (iMaxVilla < iVillaIA)
                    {
                        if ((NumVillas(game) > 0) && (uMaxVilla >= iMaxVilla))
                        {
                            Int32 mID = IDMaker.FromString(sPatricians[(int)uMaxVilla]);
                            game.GetTotalBuildings(mID, out nPV);
                            game.TriggerStructureDamage(mID, (int)nPV, 100);
                            if (iMaxVilla == 0)
                                DisplayMessage(game, "Bad_Villa1");
                            else if (iMaxVilla == 1)
                                DisplayMessage(game, "Bad_Villa2");
                            else
                                DisplayMessage(game, "Bad_Villa3");
                            iMaxVilla++;
                            iWarnIA = 0;
                        }
                        else if (iWarnIA == 8)
                        {
                            DisplayMessage(game, "Advisor_Home2");
                            iWarnIA = 0;
                        }
                    }
                    else if (uMaxVilla > 1)
                    {
                        DisplayMessage(game, "Advisor_Housed");
                        iAdvisor++;
                    }
                    else if (iWarnIA == 8)
                    {
                        DisplayMessage(game, "Advisor_Home2");
                        iWarnIA = 0;
                    }
                    iWarnIA++;
                    
                    // now check for evolved pleb and equite housing
                    game.GetActiveBuildings(mIDDomus2, out nD2);
                    game.GetActiveBuildings(mIDDomus3, out nD3);
                    game.GetActiveBuildings(mIDInsula2, out nI2);
                    game.GetActiveBuildings(mIDInsula3, out nI3);
                    if (nD2 > 0)
                    {
                        game.TriggerStructureDamage(mIDDomus2, (int)nD2, 100);
                        bEdomus = true;
                    }
                    if (nD3 > 0)
                    {
                        game.TriggerStructureDamage(mIDDomus3, (int)nD3, 100);
                        bEdomus = true;
                    }
                    if (nI2 > 0)
                    {
                        game.TriggerStructureDamage(mIDInsula2, (int)nI2, 100);
                        bEinsula = true;
                    }
                    if (nI3 > 0)
                    {
                        game.TriggerStructureDamage(mIDInsula3, (int)nI3, 100);
                        bEinsula = true;
                    }
                    if (bEdomus && bEinsula)
                        DisplayMessage(game, "Bad_Housing");
                    else if (bEdomus)
                        DisplayMessage(game, "Bad_Domus");
                    else if (bEinsula)
                        DisplayMessage(game, "Bad_Insula");
                    break;

                case 3:
                    msgTitle = "Insane_Advice_Title";
                    msgText = "Insane_Advice_Message";
                    game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                        (uint)MessageDisplay.kMessageDisplayTutorial, ref msgTitle, ref msgText, ref msgBaa);
                    nPlebWages = 9;
                    nEquiteWages = 12;
                    game.SetRomeStandardRate(true, nPlebWages);
                    game.SetRomeStandardRate(false, nEquiteWages);
                    game.UnlockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
                    game.UnlockUIControl(989726641, Toolset.AdvisorsFormID);
                    iAdvisor++;
                    tInsanityTip = nTime + 80;
                    break;

                case 4:
                    GetInsanityRating(game);
                    nInsanity = uInsanity;

                    if (nTime > tAprInsanity)
                    {
                        DisplaySpecialInsanity(game, "April");
                        if (nTime < 2400)
                            uApr39Insanity = nInsanity;
                        else
                            uApr40Insanity = nInsanity;
                        tAprInsanity += 960;
                        tInsanityCheck -= 5;     // reset back to what it was
                        game.SetRomeStandardRate(true, 0);
                        game.SetRomeStandardRate(false, 0);
                    }
                    else if (nTime > tAugInsanity)
                    {
                        DisplaySpecialInsanity(game, "August");
                        if (nTime < 2400)
                            uAug39Insanity = nInsanity;
                        else
                            uAug40Insanity = nInsanity;
                        tAugInsanity += 960;
                        game.SetRomeStandardRate(true, 0);
                        game.SetRomeStandardRate(false, 0);
                        bInsaneWage = true;
                    }
                    else
                        DisplayInsanity(game);

                    if (nInsanity > uMaxInsanity) uMaxInsanity = nInsanity;

                    if ((nTime > tInsanityTip) && (nInsanity < 100)) InsanityHint(game);
                    break;
            }
            
            tInsanityCheck += 40;
            // Detect April Insanity Day and delay slightly if needed
            if (((tInsanityCheck + 6) > tAprInsanity) && (tInsanityCheck < tAprInsanity)) tInsanityCheck = tAprInsanity;
           
        }

        //////////////////////////////////////////////
        // Controls Insanity Rating calculation 
        void GetInsanityRating(IGameQueryInterface game)
        {
            uInsanity = 0;           // initialise
            InsaneCulture(game);     // 25 points maximum
            InsaneProsperity(game);  // 25 points maximum
            InsaneSecurity(game);    // 40 points maximum
            InsanityBonus(game);     // 21 points maximum
            InsaneTreasury(game);    // +-5 points
            if (uInsanity > 101) uInsanity = 101;    
        }

        //////////////////////////////////////////////
        // Insanity Rating - Security contribution 
        // Including bonuses that are security-related
        void InsaneSecurity(IGameQueryInterface game)
        {
            bool b1 = false;
            uint nJS, nJT, numWorkers;
            
            if (nSecurity > 24)
                uISecurity = 0;
            else
                uISecurity = 25 - nSecurity;
            // plague, fire and collapse
            game.GetBuildingsPlagued(out b1);
            if (b1)
            {
                uISecurity++;
                if (!bIAplague)
                {
                    bIAplague = true;
                    DisplayWarning(game, "IA_Plague");
                }
            }
            game.GetBuildingsOnFire(out b1);
            if (b1)
            {
                uISecurity++;
                if (!bIAfire)
                {
                    bIAfire = true;
                    DisplayWarning(game, "IA_Fire");
                }
            }
            game.GetBuildingsCollapsing(out b1);
            if (b1)
            {
                uISecurity++;
                if (!bIAcollapse)
                {
                    bIAcollapse = true;
                    DisplayWarning(game, "IA_Collapse");
                }
            }
            
            // useless workers
            numWorkers = 0;
            numWorkers = CountWorkers(game);
            CountEmployees(game);
            if (numWorkers > numEmployed)
                uIWorkers = (numWorkers - numEmployed) / 200;
            else
                uIWorkers = 0;
            uIWorkers = Math.Min(uIWorkers, 5);

            // No Jupiter bonus
            game.GetActiveBuildings(mIDJupiterShrine, out nJS);
            game.GetActiveBuildings(mIDJupiterTemple, out nJT);
            if ((nJS == 0) && (nJT == 0)) uISecurity += 10;
            uISecurity = Math.Min(uISecurity, 35);
            uInsanity += uISecurity;
            uInsanity += uIWorkers;
        }

        ///////////////////////////////////////////////
        // Insanity Rating - Culture contribution 
        void InsaneCulture(IGameQueryInterface game)
        {
            uint nHouses, nPats, num, nCultured, minCR, maxCR, baseCR, n1, n2;
            uint uHealth, uReligion, uEducation, uEntertainment;
            nHouses = NumHomes(game);
            nPats = NumVillas(game);
            game.GetTotalBuildings(mIDVilla1, out num);
            nPats -= num;
            // calculate maximum initial contributions
            // Health first
            uHealth = 0;
            game.GetActiveBuildings(mIDClinic, out num);
            if (num > 0) uHealth += 2500;
            game.GetActiveBuildings(mIDBarber, out num);
            if (num > 0) uHealth += 2500;
            game.GetActiveBuildings(mIDBathhouse, out num);
            if (num > 0) uHealth += 2500;
            game.GetActiveBuildings(mIDHospital, out num);
            if (num > 0) uHealth += 2500;
            baseCR = uHealth;
            // now religion
            uReligion = 0;
            game.GetActiveBuildings(mIDJupiterShrine, out n1);
            game.GetActiveBuildings(mIDJupiterTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            game.GetActiveBuildings(mIDMercuryShrine, out n1);
            game.GetActiveBuildings(mIDMercuryTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            game.GetActiveBuildings(mIDCeresShrine, out n1);
            game.GetActiveBuildings(mIDCeresTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            game.GetActiveBuildings(mIDMarsShrine, out n1);
            game.GetActiveBuildings(mIDMarsTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            game.GetActiveBuildings(mIDBacchusShrine, out n1);
            game.GetActiveBuildings(mIDBacchusTemple, out n2);
            if ((n1 + n2) > 0) uReligion += 2000;
            if (uReligion < baseCR) baseCR = uReligion;
            // now education
            uEducation = 0;
            game.GetActiveBuildings(mIDSchool, out num);
            if (num > 0) uEducation += 7000;
            game.GetActiveBuildings(mIDLibrary, out num);
            if (num > 0) uEducation += 3000;
            if (uEducation < baseCR) baseCR = uEducation;
            // finally Entertainment
            uEntertainment = 0;
            game.GetActiveBuildings(mIDOdeum, out num);
            if (num > 0) uEntertainment += 1500;
            game.GetActiveBuildings(mIDTheater, out num);
            if (num > 0) uEntertainment += 2000;
            game.GetActiveBuildings(mIDArena, out num);
            if (num > 0) uEntertainment += 2500;
            game.GetActiveBuildings(mIDColiseum, out num);
            game.GetActiveBuildings(mIDGladiator, out n1);
            game.GetActiveBuildings(mIDAnimalTrainer, out n2);
            if ((num > 0) & (n1 > 0)) uEntertainment += 1500;
            if ((num > 0) & (n2 > 0)) uEntertainment += 3000;
            game.GetActiveBuildings(mIDCircus, out num);
            if (num > 0) uEntertainment += 1000;
            if (uEntertainment < baseCR) baseCR = uEntertainment;
            // Now we have the baseCR we can find the maximum CR
            maxCR = baseCR;
            maxCR += Math.Min(1500, (uHealth - baseCR) / 4);
            maxCR += Math.Min(1500, (uEducation - baseCR) / 4);
            maxCR += Math.Min(1500, (uReligion - baseCR) / 4);
            maxCR += Math.Min(1500, (uEntertainment - baseCR) / 4);
            
            minCR = (maxCR * nPats) / (nHouses + nPats);
            if (nCulture < minCR)
                nCultured = 0;
            else
                nCultured = (((nCulture * 100) - minCR) * nHouses) / (maxCR - minCR);

            uICulture = Math.Min(nHouses, 25);
            if (nCultured > uICulture)
                uICulture = 0;
            else
                uICulture -= nCultured;

            uInsanity += uICulture;
        }

        /////////////////////////////////////////////
        // Returns the maximum Patrician level
        uint MaxVilla(IGameQueryInterface game)
        {
            uint num, uMaxPat = 0;
            Int32 mID = 0;
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetTotalBuildings(mID, out num);
                if (num > 0) uMaxPat = (uint)i;
            }
            return uMaxPat;
        }

        //////////////////////////////////////////
        // Returns the number of Patrician houses
        uint NumVillas(IGameQueryInterface game)
        {
            uint num, numPats = 0;
            Int32 mID = 0;
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetTotalBuildings(mID, out num);
                numPats += num;
            }
            return numPats;
        }

        ////////////////////////////////////////////////////////////////////////////////////
        // Counts the number of homes for 'coverage' purposes in calculating Insanity Rating
        uint NumHomes(IGameQueryInterface game)
        {
            Int32 mID;
            uint num, nHomes = 0;
            string[] sHomes = {"C4b Plebian home 01", "C4b Plebian home 02", "C4b Plebian home 03",
                              "C4b Equites Housing 01", "C4b Equites Housing 02", "C4b Equites Housing 03"};

            for (int i = 0; i < 6; i++)
            {
                mID = IDMaker.FromString(sHomes[i]);
                game.GetActiveBuildings(mID, out num);
                nHomes += num;
            }
            return nHomes;
        }

        ///////////////////////////////////////////////
        // Insanity Rating - Prosperity contribution 
        void InsaneProsperity(IGameQueryInterface game)
        {
            uint nI1, nI2, nI3, nD1, nD2, nD3, nHomes, nPenalty;
            game.GetActiveBuildings(mIDInsula1, out nI1);
            game.GetActiveBuildings(mIDInsula2, out nI2);
            game.GetActiveBuildings(mIDInsula3, out nI3);
            game.GetActiveBuildings(mIDDomus1, out nD1);
            game.GetActiveBuildings(mIDDomus2, out nD2);
            game.GetActiveBuildings(mIDDomus3, out nD3);
            nHomes = nI1 + nI2 + nI3 + nD1 + nD2 + nD3;
            nPenalty = nI2 + 2 * nI3 + nD2 + 2 * nD3;

            if (nPenalty >= nHomes)
                uIProsperity = 0;
            else if (nHomes > 25)
                uIProsperity = 25 - nPenalty;
            else
                uIProsperity = nHomes - nPenalty;

            uInsanity += uIProsperity;
        }

        //////////////////////////////////////////////
        // Insanity Rating - Treasury contribution 
        void InsaneTreasury(IGameQueryInterface game)
        {
            if (nCityFunds < 5000)
                uIFunds = 10;
            else if (nCityFunds < 6000)
                uIFunds = 9;
            else if (nCityFunds < 7000)
                uIFunds = 8;
            else if (nCityFunds < 8000)
                uIFunds = 7;
            else if (nCityFunds < 9000)
                uIFunds = 6;
            else if (nCityFunds < 10000)
                uIFunds = 5;
            else if (nCityFunds < 12500)
                uIFunds = 4;
            else if (nCityFunds < 15000)
                uIFunds = 3;
            else if (nCityFunds < 17500)
                uIFunds = 2;
            else if (nCityFunds < 20000)
                uIFunds = 1;
            else
                uIFunds = 0;

            uInsanity += uIFunds - 5;
            
        }

        //////////////////////////////////////////////
        // Insanity Rating - Bonus contribution 
        // This is mainly down to resources but also includes useless citizens (unemployed) and useless trade routes
        void InsanityBonus(IGameQueryInterface game)
        {
            uint nIR, num, uIBonus = 0;
            bool b1, b2;
            // useless resources
            game.GetResource(mIDArmor, out num);
            nIR = num;
            game.GetResource(mIDTimber, out num);
            nIR += num;
            game.GetResource(mIDClay, out num);
            nIR += num;
            game.GetResource(mIDSand, out num);
            nIR += num;
            game.GetResource(mIDGold, out num);
            nIR += num;
            game.GetResource(mIDIron, out num);
            nIR += num;
            game.GetResource(mIDMarble, out num);
            nIR += num;
            game.GetResource(mIDWool, out num);
            uIResource = Math.Min((nIR / 64) + (num / 32), 20);
            uIBonus = uIResource;

            // useless trade routes
            game.GetIsTradeRouteOpen(7, out b1);
            game.GetIsTradeRouteOpen(8, out b2);
            if (b1 && b2)
            {
                uIBonus++;
                if (!bIAkilts)
                {
                    bIAkilts = true;
                    DisplayWarning(game, "IA_Caledonia");
                }
            }

            uInsanity += uIBonus;
            if (uInsanity > 96) uInsanity = 96;    
        }

        ///////////////////////////////////////////
        // Display a tip on improving insanity
        void InsanityHint(IGameQueryInterface game)
        {
            int iMax = 0;
            uint[] zInsanity = { 0, 0, 0, 0, 0, 0 };
            String[] sHint = { "ICulture", "IProsperity", "ISecurity", "ITreasury", "IResources", "IWorkers" };
            if (NumHomes(game) < 25)
            {
                sHint[0] = "ICulture2";
                sHint[1] = "IProsperity2";
            }
            
            zInsanity[0] = 25 - uICulture;
            zInsanity[1] = 25 - uIProsperity;
            zInsanity[2] = 25 - Math.Min(uISecurity, 25);
            zInsanity[3] = 10 - uIFunds;
            zInsanity[4] = 20 - uIResource;
            zInsanity[5] = 5 - uIWorkers;
            
            for (int i = 0; i < 5; i++)
            {
                if (zInsanity[i] > zInsanity[iMax]) iMax = i;
            }
                        
            DisplayWarning(game, (sHint[iMax] + "_Tip"));
            tInsanityTip += 320;

        }

        /////////////////////////////////////////////////////////////
        // Counts the number of housing available for equites & plebs
        // (why not just use population less patricians?)
        uint CountWorkers(IGameQueryInterface game)
        {
            uint n1, n2, n3, numWorkers;
            game.GetActiveBuildings(mIDDomus1, out n1);
            game.GetActiveBuildings(mIDDomus2, out n2);
            game.GetActiveBuildings(mIDDomus3, out n3);
            numWorkers = (n1 * 40) + (n2 * 60) + (n3 * 80);
            game.GetActiveBuildings(mIDInsula1, out n1);
            game.GetActiveBuildings(mIDInsula2, out n2);
            game.GetActiveBuildings(mIDInsula3, out n3);
            numWorkers += (n1 * 70) + (n2 * 110) + (n3 * 150);
            return numWorkers;
        }

        ///////////////////////////////////////////////////////////
        // Calculates the number of employees needed to fill all jobs
        void CountEmployees(IGameQueryInterface game)
        {
            numEmployed = 3;       // assume there is a governor's residence
            AddEmployees(game, mIDDrillYard, 54);
            AddEmployees(game, mIDFountain, 3);
            AddEmployees(game, mIDReservoir, 24);
            AddEmployees(game, mIDPumphouse, 18);
            AddEmployees(game, mIDTaxOffice, 14);
            AddEmployees(game, mIDForum, 22);
            AddEmployees(game, mIDBasilica, 36);
            AddEmployees(game, mIDOdeum, 18);
            AddEmployees(game, mIDTheater, 27);
            AddEmployees(game, mIDActor, 21);
            AddEmployees(game, mIDArena, 42);
            AddEmployees(game, mIDGladiator, 30);
            AddEmployees(game, mIDColiseum, 54);
            AddEmployees(game, mIDAnimalTrainer, 36);
            AddEmployees(game, mIDCircus, 99);
            AddEmployees(game, mIDCharioteer, 31);
            AddEmployees(game, mIDSchool, 18);
            AddEmployees(game, mIDLibrary, 45);
            AddEmployees(game, mIDClinic, 22);
            AddEmployees(game, mIDBarber, 12);
            AddEmployees(game, mIDBathhouse, 38);
            AddEmployees(game, mIDHospital, 63);
            AddEmployees(game, mIDJupiterShrine, 15);
            AddEmployees(game, mIDMarsShrine, 15);
            AddEmployees(game, mIDCeresShrine, 15);
            AddEmployees(game, mIDBacchusShrine, 15);
            AddEmployees(game, mIDMercuryShrine, 15);
            AddEmployees(game, mIDJupiterTemple, 33);
            AddEmployees(game, mIDMarsTemple, 33);
            AddEmployees(game, mIDCeresTemple, 33);
            AddEmployees(game, mIDBacchusTemple, 33);
            AddEmployees(game, mIDMercuryTemple, 33);
            // plebs
            AddEmployees(game, mIDSheepFarm, 31);
            AddEmployees(game, mIDSandCamp, 27);
            AddEmployees(game, mIDClayCamp, 27);
            AddEmployees(game, mIDLumberjack, 40);
            AddEmployees(game, mIDIronMine, 42);
            AddEmployees(game, mIDGoldMine, 42);
            AddEmployees(game, mIDMarbleCamp, 72);
            AddEmployees(game, mIDGlassFactory, 40);
            AddEmployees(game, mIDPotteryFactory, 40);
            AddEmployees(game, mIDJewelryFactory, 48);
            AddEmployees(game, mIDOliveOilFactory, 40);
            AddEmployees(game, mIDWineFactory, 48);
            AddEmployees(game, mIDUtensilsFactory, 48);
            AddEmployees(game, mIDWeaponsFactory, 63);
            AddEmployees(game, mIDFoodMarket, 18);
            AddEmployees(game, mIDBasicMarket, 27);
            AddEmployees(game, mIDLuxuryMarket, 31);
            AddEmployees(game, mIDExoticMarket, 39);
            AddEmployees(game, mIDGranary, 18);
            AddEmployees(game, mIDWarehouse, 22);
            AddEmployees(game, mIDDepot, 27);
            AddEmployees(game, mIDPort, 30);
            AddEmployees(game, mIDArmory, 54);
            AddEmployees(game, mIDMessHall, 38);
            AddEmployees(game, mIDTower, 38);
            AddEmployees(game, mIDGatehouse, 45);
        }

        ////////////////////////////////////////////////////////////////////
        // Adds the number of employees needed for the specified building
        // We count mothballed, inactive venues, untaxed markets
        void AddEmployees(IGameQueryInterface game, Int32 mID, uint iEmploy)
        {
            uint num = 0;
            game.GetTotalBuildings(mID, out num);
            numEmployed += iEmploy * num;
        }
        

        ////////////////////////////////////////////////////////////////////////////
        // Beauty rating is calculated every week
        // Current rating increases or decreases by 1 every week towards this value
        // Display every 2 weeks
        void ShowBeautyRating(IGameQueryInterface game)
        {
            uint xBeauty = nBeauty;
            GetBeautyRating(game);
            if (uBeauty > nBeauty)
                nBeauty++;
            else if (uBeauty < nBeauty)
                nBeauty--;
            if (uBeauty > nBeauty)
                nBeauty++;
            else if (uBeauty < nBeauty)
                nBeauty--;

            if ((tBeautyCheck == 7077) || (tBeautyCheck == 5157))
                DisplaySpecialBeauty(game);
            else
                DisplayBeauty(game);

            // check for perfect beauty
            if ((tPerfectBeauty == 0) && (nBeauty > 99))
            {
                tPerfectBeauty = nTime;
                GiveAcclamation(game, "Perfect_Beauty");
            }
            tBeautyCheck += 40;

            if ((uBeauty < 100) && (nTime > tBeautyTip)) BeautyHint(game);
        }

        ////////////////////////////////////////////////////////////////////////////////////
        // Controls Beauty Rating calculation - undesirable factor vs total desirable factor
        void GetBeautyRating(IGameQueryInterface game)
        {
            CountHomes(game);
            AddUndesirables(game);
            uUndes = Math.Max(uUndes, 100);
            uBeauty = 0;
            AddStatueBR(game);
            AddTHBScore(game);
            uDeco = uBeauty;
            AddGovBR(game);
            AddEntBR(game);
            AddRelBR(game);
            AddPatBR(game);
            AddOtherBR(game);
            if (uBeauty > 100) uBeauty = 100;
        }

        //////////////////////////////////////////////////////////////////////////////////
        // Counts the number of homes for 'coverage' purposes in calculating Beauty Rating
        void CountHomes(IGameQueryInterface game)
        {
            Int32 mID;
            uint num, nHomes = 0;
            string[] sHomes = {"C4b Plebian home 01", "C4b Plebian home 02", "C4b Plebian home 03",
                              "C4b Equites Housing 01", "C4b Equites Housing 02", "C4b Equites Housing 03"};

            for (int i = 0; i < 6; i++)
            {
                mID = IDMaker.FromString(sHomes[i]);
                game.GetTotalBuildings(mID, out num);
                nHomes += num;
            }
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetTotalBuildings(mID, out num);
                nHomes += num;
            }
            uUndes = nHomes * 2;
        }

        ///////////////////////////////////////////////////////////////////////////////
        // Calculates the negative effect on Beauty rating from 'undesirable' buildings
        void AddUndesirables(IGameQueryInterface game)
        {
            AddUndesirable(game, mIDCattleFarm, 1);
            AddUndesirable(game, mIDSandCamp, 1);
            AddUndesirable(game, mIDClayCamp, 1);
            AddUndesirable(game, mIDIronMine, 1);
            AddUndesirable(game, mIDGoldMine, 1);
            AddUndesirable(game, mIDLumberjack, 1);
            AddUndesirable(game, mIDMarbleCamp, 1);
            AddUndesirable(game, mIDGranary, 1);
            AddUndesirable(game, mIDWarehouse, 1);
            AddUndesirable(game, mIDDepot, 1);
            AddUndesirable(game, mIDPort, 1);
            AddUndesirable(game, mIDGlassFactory, 2);
            AddUndesirable(game, mIDPotteryFactory, 2);
            AddUndesirable(game, mIDJewelryFactory, 1);
            AddUndesirable(game, mIDUtensilsFactory, 1);
            AddUndesirable(game, mIDWeaponsFactory, 2);
            AddUndesirable(game, mIDArmory, 2);
            AddUndesirable(game, mIDMessHall, 2);
            AddUndesirable(game, mIDArchers, 4);
            AddUndesirable(game, mIDLightInfantry, 4);
            AddUndesirable(game, mIDDrillYard, 4);
        }

        /////////////////////////////////////////////////////////////////////
        // Adds the "undesirable" contribution for the specified building
        void AddUndesirable(IGameQueryInterface game, Int32 mID, uint iFactor)
        {
            uint num = 0;
            game.GetTotalBuildings(mID, out num);
            uUndes += iFactor * num;
        }

        ////////////////////////////////////////////////////////////
        // Beauty Rating from Government buildings
        void AddGovBR(IGameQueryInterface game)
        {
            uint num;
            uGovBR = nPalace(game);
            game.GetActiveBuildings(mIDBasilica, out num);
            if (num > 0) uGovBR += 3;
            uDes = uUndes / 2;
            AddWeightedBuild(game, mIDForum, 240, 3);
            uGovBR += uDes / uUndes;
            uBeauty += uGovBR;
        }

        ////////////////////////////////////////////////////////////
        // Beauty Rating from Temples & Shrines
        void AddRelBR(IGameQueryInterface game)
        {
            uDes = uUndes / 2;
            AddWeightedBuild(game, mIDJupiterTemple, 200, 2);
            AddWeightedBuild(game, mIDMarsTemple, 200, 2);
            AddWeightedBuild(game, mIDCeresTemple, 200, 2);
            AddWeightedBuild(game, mIDBacchusTemple, 200, 2);
            AddWeightedBuild(game, mIDMercuryTemple, 200, 2);
            AddFullBuild(game, mIDJupiterShrine, 40, 1);
            AddFullBuild(game, mIDMarsShrine, 40, 1);
            AddFullBuild(game, mIDCeresShrine, 40, 1);
            AddFullBuild(game, mIDBacchusShrine, 40, 1);
            AddFullBuild(game, mIDMercuryShrine, 40, 1);
            uRelBR = Math.Min((uDes / uUndes), 10);
            uBeauty += uRelBR;
        }

        //////////////////////////////////////////////
        // Beauty Rating from Entertainment buildings
        void AddEntBR(IGameQueryInterface game)
        {
            uint uMax, num;
            uDes = uUndes / 2;
            AddFullBuild(game, mIDOdeum, 160, 3);
            AddFullBuild(game, mIDActor, 160, 2);
            num = nDesVenue(game, mIDTheater, 0);
            uDes += Math.Min((num * 320), (uUndes * 4));
            uMax = uUndes * 3;
            num = nDesVenue(game, mIDArena, 1);
            uDes += Math.Min((num * 200), uMax);
            num = nDesVenue(game, mIDColiseum, 2);
            if (num > 0) uDes += uMax;
            num = nDesVenue(game, mIDCircus, 3);
            if (num > 0) uDes += uMax;
            
            uEntBR = Math.Min((uDes / uUndes), 16);
            uBeauty += uEntBR;
        }

        ////////////////////////////////////////
        // Beauty Rating from Patrician villas
        void AddPatBR(IGameQueryInterface game)
        {
            uint num;
            Int32 mID;
            uDes = uUndes / 2;
            for (int i = 0; i < 9; i++)
            {
                mID = IDMaker.FromString(sPatricians[i]);
                game.GetActiveBuildings(mID, out num);
                uDes += (uint)i * num * 20;
            }
            uPatBR = Math.Min((uDes / uUndes), 10);
            uBeauty += uPatBR;
        }

        ////////////////////////////////////////////////
        // Beauty Rating from other desirable buildings
        void AddOtherBR(IGameQueryInterface game)
        {
            uDes = uUndes / 2;
            AddFullBuild(game, mIDFountain, 160, 2);
            AddFullBuild(game, mIDLibrary, 320, 3);
            AddFullBuild(game, mIDBathhouse, 160, 3);
            AddWeightedBuild(game, mIDHospital, 120, 2);
            AddFullBuild(game, mIDExoticMarket, 160, 1);
            AddFullBuild(game, mIDLuxuryMarket, 80, 1);
            AddFullBuild(game, mIDSheepFarm, 80, 4);
            uOtherBR = Math.Min((uDes / uUndes), 8);
            uBeauty += uOtherBR;
        }

        /////////////////////////////////////////////////////////////////
        // Venues are counted as inactive even if waiting for actors etc.
        // Allow venue to be inactive for 4 weeks before losing beauty
        uint nDesVenue(IGameQueryInterface game, Int32 mID, int iVenue)
        {
            uint num1, num2 = 0;
            game.GetActiveBuildings(mID, out num1);
            game.GetInactiveBuildings(mID, out num2);
            if ((num2 > 0) && (nTime < 7620))
            {
                if (bEmptyVenue[iVenue])
                    num2 = 0;
                else
                    bEmptyVenue[iVenue] = true;
            }
            else
                bEmptyVenue[iVenue] = false;

            return (num1 + num2);
        }

        ///////////////////////////////////////////////////////////////////
        // Add to 'desirable' score capped at uMax 
        void AddFullBuild(IGameQueryInterface game, Int32 mID, uint iFactor, uint uMax)
        {
            uint num;
            game.GetActiveBuildings(mID, out num);
            uDes += Math.Min((iFactor * num), (uMax * uUndes));
        }

        ////////////////////////////////////////////////////////////////////////
        // Beauty Rating where subsequent builds count less than the first
        void AddWeightedBuild(IGameQueryInterface game, Int32 mID, uint iFactor, uint uMax)
        {
            uint num;
            game.GetActiveBuildings(mID, out num);
            if (num > 0) num++;
            uDes += Math.Min((iFactor * num), (uMax * uUndes));
        }

        /////////////////////////////////////////////
        // Beauty Rating from Statues
        void AddStatueBR(IGameQueryInterface game)
        {
            uint num, numB;
            // small statues
            game.GetTotalBuildings(mIDStatue1, out num);
            numB = Math.Min((num / 8), 3);
            game.GetTotalBuildings(mIDStatue2, out num);
            numB += Math.Min((num / 8), 3);
            uSmallST = Math.Min(numB, 4);
            uBeauty += uSmallST;
            // medium statues + obelisk
            game.GetTotalBuildings(mIDStatue3, out num);
            numB = Math.Min((num / 4), 3);
            game.GetTotalBuildings(mIDStatue4, out num);
            numB += Math.Min((num / 4), 3);
            game.GetTotalBuildings(mIDObelisk, out num);
            numB += Math.Min(((num * 3 + 1) / 5), 6);
            uMediumST = Math.Min(numB, 10);
            uBeauty += uMediumST;
            // large statues
            game.GetTotalBuildings(mIDStatue5, out num);
            numB = Math.Min((num / 2), 5);
            game.GetTotalBuildings(mIDStatue6, out num);
            numB += Math.Min(((num * 5 + 1) / 6), 5);
            uLargeST = Math.Min(numB, 8);
            uBeauty += uLargeST;
        }

        ////////////////////////////////////////////
        // Beauty Rating from Trees, Hedges & Bushes
        void AddTHBScore(IGameQueryInterface game)
        {
            uint num1, num2, uMax;
            uDes = 0;
            AddFullBuild(game, mIDGarden, 40, 5);
            uGarden = uDes / uUndes;
            uDes = 0;
            AddFullBuild(game, mIDBushSmall, 20, 3);
            AddFullBuild(game, mIDBushLarge, 40, 5);
            uBush = uDes / uUndes;
            uDes = 0;
            AddFullBuild(game, mIDTreeSmall, 20, 3);
            AddFullBuild(game, mIDTreeMedium, 40, 5);
            uTree1 = uDes / uUndes;
            uDes = 0;
            AddFullBuild(game, mIDTreeLarge, 80, 7);
            uTree2 = uDes / uUndes;
            uMax = uUndes * 3;
            uDes = uUndes / 2;
            game.GetTotalBuildings(mIDHedgeLarge, out num1);
            game.GetTotalBuildings(mIDHedgeRowLarge, out num2);
            uDes += Math.Min(((num1 + num2) * 10), uMax);
            game.GetTotalBuildings(mIDHedgeSmall, out num1);
            game.GetTotalBuildings(mIDHedgeRowSmall, out num2);
            uDes += Math.Min(((num1 + num2) * 5), uMax); 
                          
            uTHB = Math.Min(((uDes / uUndes) + uGarden + uBush + uTree1 + uTree2), 28);
            uBeauty += uTHB;
        }

        ////////////////////////////////////////
        // Beauty Rating hints from the Advisor
        void BeautyHint(IGameQueryInterface game)
        {
            int iEnd, iMax = 0;
            uint[] zBeauty = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            String[] sHint = { "Tree1", "Tree2", "Garden", "Bush", "LargeST", "MedStat", "SmallST", "GovBR", "EntBR", "PatBR", "RelBR", "OtherBR" };
            zBeauty[0] = 8 - uTree1;
            zBeauty[1] = 7 - uTree2;
            zBeauty[2] = 5 - uGarden;
            zBeauty[3] = 8 - uBush;
            zBeauty[4] = 8 - uLargeST;
            zBeauty[5] = 10 - uMediumST;
            zBeauty[6] = 4 - uSmallST;
            zBeauty[7] = 11 - uGovBR;
            zBeauty[8] = 16 - uEntBR;
            zBeauty[9] = 10 - uPatBR;
            zBeauty[10] = 10 - uRelBR;
            zBeauty[11] = 8 - uOtherBR;

            if (uDeco < 45)
                iEnd = 7;
            else
                iEnd = 12;

            for (int i = 0; i < iEnd; i++)
            {
                if (zBeauty[i] > zBeauty[iMax]) iMax = i;
            }

            DisplayWarning(game, (sHint[iMax] + "_Tip"));
            tBeautyTip = nTime + 200;
        }

        ////////////////////////////////////////////////////////////////////////////
        // Adjust Pleb & Equite wage expectations each year treasury exceeds 10000dn
        void CheckWageExpectations(IGameQueryInterface game)
        {
            if (nCityFunds >= nWageTrigger)
            {
                // advise player of changed expectations
                if (bAssassinated)
                {
                    nPlebWages += 3;
                    nEquiteWages += 4;
                    DisplayMessage(game, "Wage_Change_N");
                }
                else
                {
                    nPlebWages = 6;
                    nEquiteWages = 9;
                    if (!bWageDown)
                    {
                        DisplayMessage(game, "Wage_Change_I");
                        bWageDown = true;
                    }
                }
                
            }
            game.SetRomeStandardRate(true, nPlebWages);
            game.SetRomeStandardRate(false, nEquiteWages);
            if (bInsaneWage)
            {
                DisplayWarning(game, "Insanity_Wages");
                bInsaneWage = false;
            }
            if (bAssassinated)
                tWageCheck = nTime + 960;             // next check in 12 months time
            else
                tWageCheck = nTime + 80;              // check every month weeks
        }

        /////////////////////////////////////////////
        // Send message with applause to player
        void GiveAcclamation(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgApplause);
        }

        /////////////////////////////////////////////
        // Send basic message to player
        void DisplayMessage(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgSound);
        }

        /////////////////////////////////////////////
        // Send Insanity Day message to player
        void DisplaySpecialInsanity(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Insanity";
            msgText = "Insanity_Rating_" + nInsanity.ToString();
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgBaa);
        }

        //////////////////////////////////////////////
        // Show Insanity Rating to player
        void DisplayInsanity(IGameQueryInterface game)
        {
            DisplayWarning(game, "Insanity_Rating_" + nInsanity.ToString());
        }

        //////////////////////////////////////////////
        // Show Beauty Rating to player
        void DisplaySpecialBeauty(IGameQueryInterface game)
        {
            if (tBeautyCheck == 7077)
            {
                msgTitle = "Final_Beauty";
                uFinalBeauty = nBeauty;
            }
            else
            {
                msgTitle = "Aug42_Beauty";
                uAug42Beauty = nBeauty;
            }
            msgText = "Beauty_Rating_" + nBeauty.ToString();
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgSound);
        }

        //////////////////////////////////////////////
        // Show Beauty Rating to player
        void DisplayBeauty(IGameQueryInterface game)
        {
            DisplayWarning(game, "Beauty_Rating_" + nBeauty.ToString());
        }

        /////////////////////////////////////////////
        // Send 'warning' to player
        void DisplayWarning(IGameQueryInterface game, String msgWarn)
        {
            game.SendWarningMessage(ref msgWarn, ref msgSound);
        }

        //////////////////////////////////////////
        // Send 'riot warning' to player
        void DisplayRiot(IGameQueryInterface game, String sMessage)
        {
            msgTitle = sMessage + "_Title";
            msgText = sMessage + "_Text";
            game.SendGameMessage((uint)MessageCategory.kLocalEventMessage,
                (uint)MessageDisplay.kMessageDisplaySignificant, ref msgTitle, ref msgText, ref msgRiot);
        }

        /////////////////////////////////////////////////
        // Returns > 0 if palace built (1, 3 or 5) else 0
        private uint nPalace(IGameQueryInterface game)
        {
            UInt32 num = 0;
            game.GetActiveBuildings(mIDPalace3, out num);
            if (num > 0) return 5;
            game.GetActiveBuildings(mIDPalace2, out num);
            if (num > 0) return 3;
            game.GetActiveBuildings(mIDPalace1, out num);
            if (num > 0) return 1;
            return 0;
        }

        /////////////////////////////////////////////////////
        // Returns 0 if no palace else the ID of the building
        private Int32 mPalace(IGameQueryInterface game)
        {
            UInt32 num = 0;
            game.GetActiveBuildings(mIDPalace3, out num);
            if (num > 0) return mIDPalace3;
            game.GetActiveBuildings(mIDPalace2, out num);
            if (num > 0) return mIDPalace2;
            game.GetActiveBuildings(mIDPalace1, out num);
            if (num > 0) return mIDPalace1;
            return 0;
        }

        //////////////////////////////////////////////
        // Send timer warning message
        void TimerMessage(IGameQueryInterface game)
        {
            DisplayWarning(game, (sTimeLeft[iMessage] + "_Months_Left"));
            iMessage++;    
        }

        //////////////////////////////////////////////
        // Called to trigger the Defeat condition
        void TriggerDefeat(IGameQueryInterface game)
        {
            game.OpenTradeRoute(kDefeat);
            game.ScriptDone = true;
        }

        //////////////////////////////////////////////////////
        // return control panel buttons to their initial state
        void StopCurrentInvasion(IGameQueryInterface game)
        {
            Int32[] iCohorts;
            String orders = sCohortOrders.kFlee;
            game.BuildingsRazed = 0;
            game.StopInvasion(ref invasion, true);
            game.GetInvaderCohorts(ref invasion, out iCohorts);
            foreach (Int32 cohortID in iCohorts)
                game.SetCohortOrders(cohortID, ref orders); 
        }


        //////////////////////////////////////////////////////
        // return control panel buttons to their initial state
        private void ResetBaseUI(IGameQueryInterface game)
        {
            if (!bOdeum) game.LockUIControl(mUIIDOdeum, Toolset.MainGameFormID);
                
            if (!bTheater)
            {
                game.LockUIControl(mUIIDTheater, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDActor, Toolset.MainGameFormID);
            }
            if (!bArena)
            {
                game.LockUIControl(mUIIDArena, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDGladiator, Toolset.MainGameFormID);
            }
            if (!bColiseum) game.LockUIControl(mUIIDColiseum, Toolset.MainGameFormID);
            if (!bCircus) game.LockUIControl(mUIIDCircus, Toolset.MainGameFormID);
            if (!bClinic) game.LockUIControl(mUIIDClinic, Toolset.MainGameFormID);
            if (!bSchool) game.LockUIControl(mUIIDSchool, Toolset.MainGameFormID);
            if (!bBarber) game.LockUIControl(mUIIDBarber, Toolset.MainGameFormID);
            if (!bJupiter)
            {
                game.LockUIControl(mUIIDJupiterShrine, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDJupiterTemple, Toolset.MainGameFormID);
            }
            if (!bAssassinated)
            {
                game.LockUIControl(mUIIDTax, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDGrainFarm, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDVegFarm, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDCattleFarm, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDOliveFarm, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDGrapeFarm, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDGrainField, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDVegField, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDCattlePasture, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDOliveGrove, Toolset.MainGameFormID);
                if (nTicks > 0)
                {
                    game.LockUIControl(mUIIDSalary, Toolset.AdvisorsFormID);
                    game.LockUIControl(-732577675, Toolset.AdvisorsFormID);    
                }
            }
            if (iAdvisor < 2) game.LockUIControl(mUIIDPatHome, Toolset.MainGameFormID);
            if (iAdvisor < 3)
            {
                game.LockUIControl(989726641, Toolset.AdvisorsFormID);
                game.LockUIControl(mUIIDExoticMarket, Toolset.MainGameFormID);
            }
            if (!bBeauty)
            {
                game.LockUIControl(mUIIDBust, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDStanding, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDSmallHedgeRow, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDLargeHedgeRow, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDSmallHedge, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDLargeHedge, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDSmallBush, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDLargeBush, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDGarden, Toolset.MainGameFormID);   
                game.LockUIControl(mUIIDSmallTree, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDMediumTree, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDLargeTree, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDHuntsman, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDHorseman, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDChariot, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDWingedChariot, Toolset.MainGameFormID);
            }
            if (nTicks < 7)
            {
                game.LockUIControl(mUIIDSafety, Toolset.MainGameFormID);
                game.LockUIControl(mUIIDPrefect, Toolset.MainGameFormID);
            }
        }

        void OnBeginScenario(IGameQueryInterface game)
        {
            mMilitaryAI = new TMilitaryAI(game);
            
            // ensure the standard wage is set properly (only necessary on first load)
            mWageManagerPlebe = new StandardWageManager(game, eWageTypes.kPleb, 15);
            mWageManagerEques = new StandardWageManager(game, eWageTypes.kEques, 20);
            mWageManagerPlebe.SetGameWage(game);
            mWageManagerEques.SetGameWage(game);

            bInit = true;
            game.ScriptDone = false;
        }

        // Initialization needed on scenario load (when loading save games)
        void OnScenarioLoad(IGameQueryInterface game)
        {
            bInit = true;
            mIDPrefect = IDMaker.FromString("C4b Office Praefect");
            if (nTime < 7080) game.ScriptDone = false;
        }

        void OnInvasionArrival(IGameQueryInterface game)
        {
            Int32[] enemyCohorts;
            String invasion = game.RunInvasion;
            String[] sTargetSheep = { "C4b harvester Wool farmer's house" };
            String orders = "RazeBuildings";
            game.GetInvaderCohorts(ref invasion, out enemyCohorts);
            foreach (Int32 cohortID in enemyCohorts)
            {
                game.SetCohortOrders(cohortID, ref orders);
                game.SetCohortTargets(cohortID, ref sTargetSheep);
            }
        }

        void OnCohortTargetDestroyed(IGameQueryInterface game)
        {
            uint num = 0;
            Int32[] enemyCohorts;
            String nextOrders = "RazeBuildings";
            String invasion = game.RunInvasion;
            String[] sTargetSheep = { "C4b harvester Wool farmer's house" };
            String[] sTargetHomes = { "C4b Patrician home 01","C4b Patrician home 02","C4b Patrician home 03",
                    "C4b Patrician home 04","C4b Patrician home 05","C4b Patrician home 06",
                    "C4b Patrician home 07","C4b Patrician home 08","C4b Patrician home 09"};
            game.SetCohortOrders(game.RunCohortID, ref nextOrders);
            game.GetTotalBuildings(mIDSheepFarm, out num);
            game.GetInvaderCohorts(ref invasion, out enemyCohorts);
            foreach (Int32 cohortID in enemyCohorts)
            {
                game.SetCohortOrders(cohortID, ref nextOrders);
                if (num > 0)
                    game.SetCohortTargets(cohortID, ref sTargetSheep);
                else
                    game.SetCohortTargets(cohortID, ref sTargetHomes);
            }           
        }
    }
}

